<?php

 // kvůli detekci češtiny
 // šťž ěščřžýáíéúůťďňó šťž šťž
 // ŠŤŽ ĚŠČŘŽÝÁÍÉÚŮŤĎŇÓ ŠŤŽ ŠŤŽ

 /*****************************************************************************/
 /**                                                                          */
 /**   PHP Manual pro PsPad                                                   */
 define('VERZE', '0.3.3');
 /** datum: 2011-11-18                                                        */
 /** datum php manualu: 2011-11-18                                            */
 /** Copyright (c) 2011 by Miroslav Svrček (phpmanual@svrcek.cz)              */
 /** http://phpmanual.svrcek.cz/                                              */
 /**                                                                          */
 /** This program is free software. - Toto je bezplatný a svobodný software.  */
 /**                                                                          */
 /** Program je šířen tak jak je, můžete ho šířit dál se zachováním původního */
 /** copyrightu, který můžete dál rozšířit v případě dalších úprav programu.  */
 /** Program můžete libovolně upravovat dle svých potřeb.                     */
 /**                                                                          */
 /** Program je šířen bez jakékoliv záruky nebo odpovědnosti za jakoukoliv    */
 /** škodu.                                                                   */
 /**                                                                          */
 /*****************************************************************************/

  $db=mysqli_connect('db_server', 'db_user', 'db_password', 'db_name');

  // true povoli zjistovani novych verzi z webu phpmanual.svrcek.cz
  $internet=false;

  // true pouziva lokalni html manual
  // false vytvari odkazy na oficialni mirror php manualu
  $lokalni_php_manual=true;

  // url mirroru php manualu, pouzita pro tvorbu odkazu
  // pri $lokalni_php_manual=false
  $url_php_manualu='http://cz2.php.net/manual/en/';

  @mysqli_query($db, "SET NAMES 'utf8'");

  header ('Content-Type: text/html; charset=utf-8');
  $datum=gmdate('D, d M Y H:i:s');
  header('Expires: ' . $datum);
  header('Last-Modified: ' . $datum);
  header('Cache-Control: no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0');
  header('Pragma: no-cache');

  $sql="SELECT odkaz, SUBSTRING_INDEX(odkaz, '.', 2) AS verze FROM odkazy WHERE prikaz = '{~VERZE~}'";
  @$sl=mysqli_query($db, $sql);
  if ($sl === false) {
      echo "Chyba SQL 01\r\n";
      echo "$sql\r\n";
      echo mysqli_error($db), "\r\n";
      }
    elseif ($line=mysqli_fetch_assoc($sl)) {
      define('VERZE_DB', $line['odkaz']);
      define('VERZE_DB1', $line['verze']);
      }
    else {
      echo "Chyba SQL 02\r\n";
      echo "$sql\r\n";
      echo mysqli_error($db), "\r\n";
      }
  
  $sql="SELECT odkaz FROM odkazy WHERE prikaz = '{~DATUM_MAN~}'";
  @$sl=mysqli_query($db, $sql);
  if ($sl === false) {
      echo "Chyba SQL 01\r\n";
      echo "$sql\r\n";
      echo mysqli_error($db), "\r\n";
      }
    elseif ($line=mysqli_fetch_assoc($sl)) {
      define('DATUM_MAN', $line['odkaz']);
      }
    else {
      echo "Chyba SQL 02\r\n";
      echo "$sql\r\n";
      echo mysqli_error($db), "\r\n";
      }

  if (! isset($_GET['q']) or trim($_GET['q']) == '') {
    $_GET['q']='co_jsem';
    }
  if (! isset($_GET['retry'])) {
    $_GET['retry']=0;
    }
  $_GET['retry']=(int)$_GET['retry'];
  define('VERZE1', preg_replace('/(\d+)\.(\d+)\.(\d+)/', '${1}.${2}', VERZE));
  if (VERZE1 != VERZE_DB1) {
      zahlavi(true);
      echo '<h1 align="center">Verze databáze neodpovídá verzi programu<br><a href="http://phpmanual.svrcek.cz/" target="_blank">Upgradujte i program</a></h1>', "\r\n";
      echo '<p align="center">Verze databáze: <b>', htmlspecialchars(VERZE_DB), "</b><br>\r\n";
      echo 'Verze programu: <b>', htmlspecialchars(VERZE), "</b><br>\r\n</p>\r\n";
      zapati(true);
      }
    elseif ($_GET['q'] == 'co_jsem') {
      zahlavi();
      echo "<h1>PHP manuál pro PsPad</h1>\r\n";
      echo '<form method="get">', "\r\n";
      echo '<input type="text" name="q"> <input type="submit" value="Hledej">', "\r\n";
      echo "</form>\r\n";
      echo '<p>Verze databáze: <b>', htmlspecialchars(VERZE_DB), "</b><br>\r\n";
      echo 'Verze programu: <b>', htmlspecialchars(VERZE), "</b><br>\r\n";
      echo 'Lokální PHP manuál ze dne: <b>', date('j.n.Y', strtotime($man_lokalni=lokalni_php())), "</b><br>\r\n";
      if (DATUM_MAN != $man_lokalni) {
        echo 'Databáze je vhodná pro PHP manuál ze dne: <b>', date('j.n.Y', strtotime(DATUM_MAN)), "</b><br>\r\n";
        }
      if ($internet) {
          echo "<br>\r\nPHP manuál na www.php.net je ze dne: <b>", date('j.n.Y', strtotime($man_oficialni=oficialni_php())), (($man_oficialni == $man_lokalni)?' - OK':' <span style="color: red;">CHYBNÁ VERZE</span>'), "</b><br>\r\n";
          aktualni(VERZE_DB, VERZE, $man_lokalni, $man_oficialni);
          }
        else {
          echo "<b><i>Není povoleno zjišťování informací z internetu v konfiguraci programu<br>jako je aktuální verze PHP manuálu či tohoto programu</i></b>\r\n";
          }
      echo "</p>\r\n";
      zapati();
      }
    else {
      if ($_GET['retry']) {
          // opakovany dotaz na hledani obdobnych prikazu
          $sql="SELECT DISTINCT odkaz, nazev, url, popis FROM odkazy LEFT JOIN kategorie ON odkazy.odkaz = kategorie.soubor  WHERE prikaz LIKE '%" . mysqli_real_escape_string($db, $_GET['q']) . "%' ORDER BY popis, nazev";
          }
        else {
          // prvni dotaz na presny nazev prikazu
          $sql="SELECT odkaz, nazev, url, popis FROM odkazy LEFT JOIN kategorie ON odkazy.odkaz = kategorie.soubor  WHERE prikaz = '" . mysqli_real_escape_string($db, $_GET['q']) . "' ORDER BY popis";
          }
      @$sl=mysqli_query($db, $sql);
      if ($sl === false) {
          echo "Chyba SQL 03\r\n";
          echo "$sql\r\n";
          echo mysqli_error($db), "\r\n";
          }
        else {
          if ($sl->num_rows == 1) {
              // naslo prave jeden zaznam
              $line=mysqli_fetch_assoc($sl);
              if (($line['odkaz'] > '') and file_exists("./{$line['odkaz']}")) {
                  // existuje soubor s napovedou, tak se zobrazi
                  if ($lokalni_php_manual) {
                      readfile("./{$line['odkaz']}");
                      }
                    else {
                      header('Location: ' . $url_php_manualu . strtr($line['odkaz'], array('.html' => '.php')));
                      }
                  }
                else {
                  // v databazi je zaznam na neexistujici soubor k danemu prikazu
                  zahlavi();
                  echo '<h1>Nenašel se soubor <span style="color: red;">', htmlspecialchars($line['odkaz']), '</span> pro klíčové slovo <span style="color: red;">', htmlspecialchars($_GET['q']), "</span></h1>\r\n";
                  echo '<p style="font-size: 17px; font-style: italic;">Můžete mi dát vědět na email <span style="font-style: normal; font-weight: bold;">phpmanual@svrcek.cz</span>, abych klíčové slovo přidal do databáze.', "</p>\r\n";  
                  zapati();
                  }  
              }
            elseif ($sl->num_rows > 1) {
              // naslo vice zaznamu
              zahlavi();
              if ($_GET['retry']) {
                  // opakovany dotaz na hledani obdobnych prikazu a jejich zobrazeni
                  echo '<h1>Klíčové slovo <span style="color: red;">', htmlspecialchars($_GET['q']), "</span> nebylo nalezeno<br>zobrazují se podobná</h1>\r\n";
                  echo '<form method="get">', "\r\n";
                  echo '<input type="text" name="q"> <input type="submit" value="Hledej">', "\r\n";
                  echo "</form>\r\n<p>\r\n";
                  }
                else {
                  // prvni dotaz na presny nazev prikazu, ktery se povedl
                  echo '<h1>', htmlspecialchars($_GET['q']), "</h1>\r\n<p>\r\n";
                  }
              while ($line=mysqli_fetch_assoc($sl)) {
                if ($lokalni_php_manual) {
                    echo '<a href="', htmlspecialchars($line['odkaz']), '">';
                    }
                  else {
                    echo '<a href="', $url_php_manualu, htmlspecialchars(strtr($line['odkaz'], array('.html' => '.php'))), '">';
                    }
                echo htmlspecialchars($line['popis']), '</a> - ';
                if ($lokalni_php_manual) {
                    echo '<a href="', htmlspecialchars($line['url']), '">';
                    }
                  else {
                    echo '<a href="', $url_php_manualu, htmlspecialchars(strtr($line['url'], array('.html' => '.php'))), '">';
                    }
                echo htmlspecialchars($line['nazev']), "</a><br>\r\n";
                }
              echo "</p>\r\n";  
              zapati();
              }
            else {
              if ($_GET['retry']) {
                  // opakovany dotaz na hledani obdobnych prikazu nic nenasel
                  zahlavi();
                  echo '<h1>Klíčové slovo <span style="color: red;">', htmlspecialchars($_GET['q']), "</span> není v databázi</h1>\r\n";
                  echo '<p style="font-size: 17px; font-style: italic;">Můžete mi dát vědět na email <span style="font-style: normal; font-weight: bold;">phpmanual@svrcek.cz</span>, abych klíčové slovo přidal do databáze.', "</p>\r\n";
                  echo '<form method="get">', "\r\n";
                  echo '<input type="text" name="q"> <input type="submit" value="Hledej">', "\r\n";
                  echo "</form>\r\n";
                  zapati();
                  }
                else {
                  // prvni dotaz na presny nazev prikazu nic nenasel, opakovani na hledani podobnych prikazu
                  header('Location: ' . $_SERVER['PHP_SELF'] . '?q=' . urlencode($_GET['q']) . '&retry=1');
                  }
              }
          }  
      }  

  mysqli_close($db);

  
 /*****************************************************************************/
 /**                                                                          */
 /** Konec programu - pouze definice funkci                                   */
 /**                                                                          */
 /*****************************************************************************/

  
  function zahlavi($centruj=false) {
    global $lokalni_php_manual, $url_php_manualu;

    echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="cz">
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <meta http-equiv="Cache-Control" content="no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0">
  <meta http-equiv="Pragma" content="no-cache">
  <meta name="Description" content="PHP manuál pro PsPad">
  <meta name="Keywords" content="php, help, manual, dokumentace, documentation, pspad">
  <meta name="Author" content="all: Miroslav Svrček; phpmanual@svrcek.cz">
  <meta name="generator" content="PSPad editor, www.pspad.com">
  <title>PHP manuál pro PsPad</title>
  <style type="text/css">
    p { font-size: 20px; }
  </style>
  
</head>
<body style="padding-left: 10%; padding-right: 10%;">
<p ' . (($centruj)?' text-align: center;':'') . '"><a href="' . (($lokalni_php_manual)?'index.html':$url_php_manualu . 'index.php') . '">Úvodní stránka PHP manuálu</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="' . (($lokalni_php_manual)?'indexes.html':$url_php_manualu . 'indexes.php') . '">Abecední přehled funkcí PHP</a></p>';
    }

  function zapati($centruj=false) {
    global $lokalni_php_manual, $url_php_manualu;

    echo '<p ', (($centruj)?' text-align: center;':''), '"><a href="' . (($lokalni_php_manual)?'index.html':$url_php_manualu . 'index.php') . '">Úvodní stránka PHP manuálu</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="' . (($lokalni_php_manual)?'indexes.html':$url_php_manualu . 'indexes.php') . '">Abecední přehled funkcí PHP</a></p>';
    echo '<p style="font-size: 12px;', (($centruj)?' text-align: center;':''), '"><a href="http://phpmanual.svrcek.cz/" target="_blank">www</a>&nbsp;&nbsp;&nbsp;Copyright (c) 2011 by Miroslav Svrček&nbsp;&nbsp;&nbsp;<a href="' . $_SERVER['PHP_SELF'] . '">verze programu</a></p>
</body>
</html>';
    }

  function lokalni_php() {
    global $lokalni_php_manual;

    if ($lokalni_php_manual) {
        $vstup=fopen('index.html', 'r');
        $soubor=fread($vstup, 4096);
        fclose($vstup);
        $regv='<div class="pubdate">([^<]*)</div>';
        preg_match('~' . $regv . '~sU', $soubor, $vysledek);
        return date('Y-m-d', strtotime($vysledek[1]));
        }
      else {
        return oficialni_php();
        }
    }

  function oficialni_php() {
    global $lokalni_php_manual;

    if ($vstup=fopen('http://www.php.net/download-docs.php', 'r')) {
        $soubor='';
        while (! feof($vstup)) {
          $soubor.=fread($vstup, 4096);
          }
        fclose($vstup);
        $regv='<td align="center" class="highlight"><a href="/get/php_manual_en.tar.gz/from/a/mirror">tar.gz</a><br /><small>[^<]*<br />Date:([^<]*)</small></td>';
        preg_match('~' . $regv . '~sUu', $soubor, $vysledek);
        return date('Y-m-d', strtotime($vysledek[1]));
        }
      else {
        return '1970-01-01';
        }
    }

  function aktualni($db, $prg, $php_lok, $php_ofic) {
    global $lokalni_php_manual;

    if ($vstup=file('http://phpmanual.svrcek.cz/verze.info', FILE_IGNORE_NEW_LINES)) {
        if (version_compare($vstup[0], $db) > 0) {
          echo 'Na webu je novější verze databáze: <b>', htmlspecialchars($vstup[0]), "</b><br>\r\n";
          }
        if (version_compare($vstup[1], $prg) > 0) {
          echo 'Na webu je novější verze programu: <b>', htmlspecialchars($vstup[1]), "</b><br>\r\n";
          }
        if ($php_lok != $vstup[2]) {
          echo 'Program na webu je pro PHP manuál ze dne: <b>', htmlspecialchars(date('j.n.Y', strtotime($vstup[2]))), "</b><br>\r\n";
          if ($php_ofic == $vstup[2]) {
            echo '<b><a href="http://www.php.net/get/php_manual_en.tar.gz/from/this/mirror" target="_blank">Doporučuji stáhnout novou verzi PHP manuálu</a></b><br>', "\r\n";
            }
          }
        }
      else {
        echo "Nelze zjistit z webu aktuální verze programu a databáze<br>\r\n";
        }
    }

?>
